## sandsifter 1.04

=== Makefile ===
# sand sifter make file
#
# in x86, instructions run in 32 bit mode sometimes differ from the same
# instructions run in 64 bit mode.  for this reason, it can be beneficial to
# fuzz both 32 and 64 bit instructions.  this requires a 32 and 64 bit binary.
# afaict, capstone will not let you simultaneously install both 32 and 64 bit
# versions.  to overcome this, we statically link to capstone.  to build both a
# 32 bit and 64 bit injector:
#
# - build and install 32 bit capstone:
#   ./make.sh nix32
#   sudo ./make.sh nix32 install
#
# - build the 32 bit injector:
#   make CFLAGS=-m32
#   mv injector injector_32
#
# - build and install 64 bit capstone:
#   ./make.sh
#   sudo ./make.sh install
#
# - build the 64 bit injector:
#   make injector
#   mv injector injector_64
#
# you can now copy injector_32 and injector_64 to 'injector' before running
# ./sifter.py in order to explore that facet of the architecture.
#
#TODO: i don't know if i was ever able to get a statically linked capstone to
# work like i describe above

all: injector

injector: injector.o
	$(CC) $(CFLAGS) $(LIBS) $(LDFLAGS) $< -Wall -static -no-pie -l:libcapstone.a -o sifter-injector -pthread

%.o: %.c
	$(CC) $(CFLAGS) -c -g $< -o $@ -Wall

clean:
	rm -f *.o sifter-injector

## sandsifter 1.03

=== debian/changelog ===
sandsifter (1.03-2) unstable; urgency=medium

  * Update upstream metadata
  * d/compat:
    - Bump compat version to 12
  * d/control:
    - Bump Standards-Version to 4.3.0
    - Bump debhelper to 12
  * d/copyright:
    - Fix missing copyright information (Closes: #906246)

 -- SZ Lin (林上智) <szlin@debian.org>  Tue, 15 Jan 2019 09:47:39 +0800

sandsifter (1.03-1) unstable; urgency=low

  * Import new upstream release
  * d/control:
    - Bump python support version to 2.7
    - Set Multi-Arch to "allowed" since it depends on architecture-dependent
      package
  * d/install
    - Fix installation path

 -- SZ Lin (林上智) <szlin@debian.org>  Fri, 21 Sep 2018 13:37:51 +0800

sandsifter (1.02-1) UNRELEASED; urgency=low

  * Initial release

 -- SZ Lin (林上智) <szlin@debian.org>  Tue, 04 Sep 2018 18:13:53 +0800

=== debian/control ===
Source: sandsifter
Section: utils
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: SZ Lin (林上智) <szlin@debian.org>
Build-Depends: debhelper (>= 12),
               libcapstone-dev,
               python (>= 2.7)
X-Python-Version: >= 2.7
Standards-Version: 4.3.0
Homepage: https://github.com/rigred/sandsifter
Vcs-Browser: https://salsa.debian.org/pkg-security-team/sandsifter
Vcs-Git: https://salsa.debian.org/pkg-security-team/sandsifter.git

Package: sandsifter
Architecture: amd64 i386
Depends: ${misc:Depends}, ${shlibs:Depends},
         python (>= 2.7),
         python-capstone
Recommends: binutils,
            nasm
Description: x86 processor fuzzer
 The sandsifter audits x86 processors for hidden instructions and
 hardware bugs, by systematically generating machine code to search
 through a processor's instruction set, and monitoring execution for
 anomalies. Sandsifter has uncovered secret processor instructions from
 every major vendor; ubiquitous software bugs in disassemblers,
 assemblers, and emulators; flaws in enterprise hypervisors; and both
 benign and security-critical hardware bugs in x86 chips.
 .
 With the multitude of x86 processors in existence, the goal of the
 tool is to enable users to check their own systems for hidden
 instructions and bugs.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_CFLAGS_MAINT_APPEND  = -Wall -no-pie
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_install:
	dh_install
	mv debian/sandsifter/usr/sbin/sifter-summarize.py debian/sandsifter/usr/sbin/sifter-summarize
	mv debian/sandsifter/usr/sbin/sifter.py debian/sandsifter/usr/sbin/sifter

override_dh_auto_clean:
	rm -f *.o sifter-injector
	find . -name "*.pyc" | xargs rm -f

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/rigred/sandsifter/releases \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## sandsifter 1.04

=== debian/changelog ===
sandsifter (1.04-1) unstable; urgency=medium

  * Import new upstream release (Closes: #932133)
  * d/control:
    - Bump Standards-Version to 4.4.0
  * d/watch:
    - Fix malformed filenamemangle

 -- SZ Lin (林上智) <szlin@debian.org>  Mon, 05 Aug 2019 13:38:37 +0800

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                libcapstone-dev,
                python (>= 2.7)
 X-Python-Version: >= 2.7
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://github.com/rigred/sandsifter
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/sandsifter
 Vcs-Git: https://salsa.debian.org/pkg-security-team/sandsifter.git

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/sandsifter-$1\.tar\.gz/ \
   https://github.com/rigred/sandsifter/releases \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
